using FluentValidation;
using CMSMicroservice.Protobuf.Protos.User;
namespace CMSMicroservice.Protobuf.Validator.User;

public class SetPasswordForUserRequestValidator : AbstractValidator<SetPasswordForUserRequest>
{
    public SetPasswordForUserRequestValidator()
    {
        RuleFor(model => model.UserId)
            .NotNull();
        RuleFor(model => model.NewPassword)
            .NotEmpty();
        RuleFor(model => model.ConfirmPassword)
            .NotEmpty();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<SetPasswordForUserRequest>.CreateWithOptions((SetPasswordForUserRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
